=== debian/changelog ===
psi-plus (1.3.400-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.2.0 (was 4.1.4): no changes required.
  * Add build dependency from libsecret-1-dev after changes in qtkeychain
    0.9.0-1. This is temporary workaround until bug #905659 is fixed.
  * Disable BUILD_DEV_PLUGINS configuration option in debian/rules and
    update debian/copyright: OMEMO plugin was moved from "dev" to "generic"
    section of plugins.
  * Update debian/control:
    - delete word "Jabber" from short descriptions of packages: current name
      of protocol ("XMPP") is more widely used nowadays
    - update long description of packages
  * Update translations in debian/psi-plus-webkit.desktop.
  * Add debian/psi-plus-common.lintian-overrides.
  * Rewrite debian/psi-plus*.1 files (man pages).

 -- Boris Pek <tehnick@debian.org>  Wed, 08 Aug 2018 02:22:18 +0300

psi-plus (1.3.384-1) unstable; urgency=medium

  * New upstream release.
  * Fix lintian note file-contains-trailing-whitespace.
  * Bump Standards-Version to 4.1.4 (was 4.1.3): no changes required.

 -- Boris Pek <tehnick@debian.org>  Mon, 18 Jun 2018 00:41:47 +0300

psi-plus (1.3.287-1) unstable; urgency=medium

  * Add build dependencies from libsignal-protocol-c-dev and libssl-dev.
  * Update configuration options in debian/rules:
    - delete USE_QT5 (not available anymore; all builds are with Qt 5.x)
    - enable BUILD_DEV_PLUGINS (enable plugins which are in active development
      mode; this enables build and installation of OMEMO plugin)
  * Add debian/psi-plus-webkit.docs.
  * Update debian/psi-plus.docs.

 -- Boris Pek <tehnick@debian.org>  Sat, 10 Mar 2018 03:07:38 +0300
