=== debian/control ===
Source: psi-plus
Section: net
Priority: optional
Maintainer: Boris Pek <tehnick@debian.org>
Uploaders: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
Build-Depends: cmake,
               debhelper (>= 11~),
               libhunspell-dev,
               libidn11-dev,
               libminizip-dev,
               libotr5-dev | libotr2-dev,
               libqca-qt5-2-dev,
               libqt5svg5-dev,
               libqt5webkit5-dev,
               libqt5x11extras5-dev,
               libsecret-1-dev,
               libsignal-protocol-c-dev,
               libsm-dev,
               libssl-dev,
               libtidy-dev,
               libxss-dev,
               qt5keychain-dev,
               qtmultimedia5-dev,
               zlib1g-dev
Homepage: https://psi-plus.com/
Vcs-Git: https://salsa.debian.org/xmpp-team/psi-plus.git
Vcs-Browser: https://salsa.debian.org/xmpp-team/psi-plus
Standards-Version: 4.2.0

Package: psi-plus
Architecture: any
Depends: psi-plus-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         libqca-qt5-2-plugins
Recommends: psi-plus-l10n,
            psi-plus-plugins,
            psi-plus-sounds,
            sox
Suggests: xdg-utils
Description: Qt-based XMPP client (basic version)
 This package contains basic version of Psi+. Use it if you prefer old
 fashioned plain text chats from era of IRC heyday.
 .
 Psi IM is a capable XMPP client aimed at experienced users. There are
 keybindings for just about everything, Unicode is supported throughout,
 contacts are cached offline. Security is also a major consideration, and
 Psi IM provides it for both client-to-server (TLS) and client-to-client
 (GnuPG, OTR, OMEMO).
 .
 Psi+ is a development branch of Psi IM. Project purposes are:
 implementation of new features, writing of patches and plugins for
 transferring them to Psi IM.
 .
 Full list of features you may found at: http://psi-plus.com/wiki/en:features

Package: psi-plus-webkit
Architecture: any
Depends: psi-plus-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         libqca-qt5-2-plugins
Recommends: psi-plus-l10n,
            psi-plus-plugins,
            psi-plus-skins,
            psi-plus-sounds,
            sox
Suggests: xdg-utils
Description: Qt-based XMPP client (WebKit version)
 This package contains WebKit version of Psi+. In comparing with basic Psi+
 version it has few additional features: support of animated emoticons, support
 of (adium) themes in private chats and group chats, support of previewing of
 images and videos in private chats and group chats, etc..
 .
 Psi IM is a capable XMPP client aimed at experienced users. There are
 keybindings for just about everything, Unicode is supported throughout,
 contacts are cached offline. Security is also a major consideration, and
 Psi IM provides it for both client-to-server (TLS) and client-to-client
 (GnuPG, OTR, OMEMO).
 .
 Psi+ is a development branch of Psi IM. Project purposes are:
 implementation of new features, writing of patches and plugins for
 transferring them to Psi IM.
 .
 Full list of features you may found at: http://psi-plus.com/wiki/en:features

Package: psi-plus-common
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: common files for Psi+
 This package contains common files for Psi+.
 .
 Psi IM is a capable XMPP client aimed at experienced users. There are
 keybindings for just about everything, Unicode is supported throughout,
 contacts are cached offline. Security is also a major consideration, and
 Psi IM provides it for both client-to-server (TLS) and client-to-client
 (GnuPG, OTR, OMEMO).
 .
 Psi+ is a development branch of Psi IM. Project purposes are:
 implementation of new features, writing of patches and plugins for
 transferring them to Psi IM.
 .
 Full list of features you may found at: http://psi-plus.com/wiki/en:features

Package: psi-plus-plugins
Architecture: any
Depends: psi-plus (=${binary:Version}) | psi-plus-webkit (=${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: plugins for Psi+
 This package contains plugins for Psi+.
 .
 Psi IM is a capable XMPP client aimed at experienced users. There are
 keybindings for just about everything, Unicode is supported throughout,
 contacts are cached offline. Security is also a major consideration, and
 Psi IM provides it for both client-to-server (TLS) and client-to-client
 (GnuPG, OTR, OMEMO).
 .
 Psi+ is a development branch of Psi IM. Project purposes are:
 implementation of new features, writing of patches and plugins for
 transferring them to Psi IM.
 .
 Full list of features you may found at: http://psi-plus.com/wiki/en:features

Package: psi-plus-skins
Architecture: all
Depends: psi-plus | psi-plus-webkit, psi-plus-plugins, ${misc:Depends}
Multi-Arch: foreign
Description: skins for Psi+
 This package contains skins for Psi+.
 .
 Psi IM is a capable XMPP client aimed at experienced users. There are
 keybindings for just about everything, Unicode is supported throughout,
 contacts are cached offline. Security is also a major consideration, and
 Psi IM provides it for both client-to-server (TLS) and client-to-client
 (GnuPG, OTR, OMEMO).
 .
 Psi+ is a development branch of Psi IM. Project purposes are:
 implementation of new features, writing of patches and plugins for
 transferring them to Psi IM.
 .
 Full list of features you may found at: http://psi-plus.com/wiki/en:features

Package: psi-plus-sounds
Architecture: all
Depends: psi-plus | psi-plus-webkit, ${misc:Depends}
Multi-Arch: foreign
Description: sound files for Psi+
 This package contains sound files for Psi+.
 .
 Psi IM is a capable XMPP client aimed at experienced users. There are
 keybindings for just about everything, Unicode is supported throughout,
 contacts are cached offline. Security is also a major consideration, and
 Psi IM provides it for both client-to-server (TLS) and client-to-client
 (GnuPG, OTR, OMEMO).
 .
 Psi+ is a development branch of Psi IM. Project purposes are:
 implementation of new features, writing of patches and plugins for
 transferring them to Psi IM.
 .
 Full list of features you may found at: http://psi-plus.com/wiki/en:features
