=== debian/rules ===
#!/usr/bin/make -f

PACKAGE = psi-plus

DEBIAN_PATH := $(abspath $(dir $(MAKEFILE_LIST)))
USCAN_REPORT = $(shell uscan --noconf --report --dehs $(DEBIAN_PATH))
CUR_VER = $(shell echo "$(USCAN_REPORT)" | sed -n 's/.*<upstream-version>\(.*\)<\/upstream-version>.*/\1/p')
CUR_URL = $(shell echo "$(USCAN_REPORT)" | sed -n 's/.*<upstream-url>\(.*\)<\/upstream-url>.*/\1/p')

export DEB_CXXFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

BUILDDIR1 = $(CURDIR)/debian/builddir1
BUILDDIR2 = $(CURDIR)/debian/builddir2
DESTDIR   = $(CURDIR)/debian/tmp

CMAKEOPTS = -DBUNDLED_IRIS=ON \
            -DUSE_HUNSPELL=ON \
            -DUSE_ENCHANT=OFF \
            -DUSE_KEYCHAIN=ON \
            -DUSE_WEBENGINE=OFF \
            -DUSE_CCACHE=OFF \
            -DONLY_PLUGINS=OFF \
            -DBUILD_DEV_PLUGINS=OFF \
            -DSEPARATE_QJDNS=OFF \
            -DVERBOSE_PROGRAM_NAME=ON

OPTSSTEP1 = -DENABLE_PLUGINS=ON \
            -DENABLE_WEBKIT=OFF

OPTSSTEP2 = -DENABLE_PLUGINS=OFF \
            -DENABLE_WEBKIT=ON

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -B$(BUILDDIR1) -- $(CMAKEOPTS) $(OPTSSTEP1)
	dh_auto_configure -B$(BUILDDIR2) -- $(CMAKEOPTS) $(OPTSSTEP2)

override_dh_auto_build:
	dh_auto_build -B$(BUILDDIR1)
	dh_auto_build -B$(BUILDDIR2)

override_dh_auto_test:
	dh_auto_test -B$(BUILDDIR1)
	dh_auto_test -B$(BUILDDIR2)

override_dh_auto_install:
	dh_auto_install -B$(BUILDDIR1) --destdir=$(DESTDIR)
	cp -a $(BUILDDIR2)/psi/psi-plus-webkit $(DESTDIR)/usr/bin/
	cp -a $(CURDIR)/debian/psi-plus*.desktop $(DESTDIR)/usr/share/applications/
	cp -a $(CURDIR)/skins $(DESTDIR)/usr/share/psi-plus/
	cp -a $(CURDIR)/themes $(DESTDIR)/usr/share/psi-plus/

get-orig-source:
	wget -c "$(CUR_URL)" -O "$(PACKAGE)_$(CUR_VER).orig.tar.gz"
